.text

.global nzd

.align 2

@ implementacija funkcije nzd iterativnim
@ euklidovim algoritmom

@ unsigned nzd(unsigned x, unsigned y)
@   r0            r0         r1
nzd:
    push {fp, lr}
    mov fp, sp
    push {r4, r5}
    
    @ Koristimo r4 i r5 registre kako bi
    @ izbegli stavljanje stvari na stek u 
    @ petlji pre poziva funkcije. Ovime 
    @ mozemo ustedeti vreme, a i sama 
    @ implementacija je laksa
    mov r4, r0              @ r4 - x
    mov r5, r1              @ r5 - y

petlja:
    cmp r5, #0
    beq kraj_petlje

        mov r0, r4
        mov r1, r5
        bl mod      @ r0 = r0 % r1 = x % y

        mov r4, r5
        mov r5, r0

    b petlja
kraj_petlje:

    mov r0, r4

    pop {r4, r5}
    mov sp, fp
    pop {fp, pc}

@ implementacija ostatka pri deljenju uzastopnim
@ oduzimanjem
@ unsigned mod(unsigned x, unsigned y)
@   r0           r0            r1
mod:
    cmp r0, r1
    blo kraj_mod
    sub r0, r0, r1
    b mod
kraj_mod:
    mov pc, lr
